package cn.estsh.i3plus.ext.mes.pcn.apiservice.controller.busi;

import cn.estsh.i3plus.ext.mes.pcn.api.base.IMesTemplateService;
import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesPullingOrderInfoService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.*;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 拉动单
 */
@Api("拉动单扫描工位端")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN+ "/mesPullingOrderInfo")
public class MesPullingOrderInfoController {

    @Autowired
    private IMesPullingOrderInfoService mesPullingOrderInfoService;

    @Autowired
    private IMesTemplateService mesTemplateService;
    @GetMapping(value = "/query-pager")
    @ApiOperation(value = "查询拉动单")
    public ResultBean queryMesProdShiftRecord(MesPullingOrderInfo mesPullingOrderInfo, Pager pager) {
        try {
            mesPullingOrderInfo.setOrganizeCode(mesPullingOrderInfo.getOrganizeCode());
            ListPager<MesProdShiftRecord> partInspectionListPager = mesPullingOrderInfoService.queryMesPullingOrderInfoByPager(mesPullingOrderInfo, pager);
            return ResultBean.success("查询成功").setListPager(partInspectionListPager);

        } catch (ImppBusiException e) {
            return ResultBean.fail(e).build();
        } catch (Exception e) {
            return ResultBean.fail(e);
        }
    }
    @PostMapping(value = "/doScan")
    @ApiOperation(value = "拉动单扫描")
    public ResultBean doMesPullingOrderInfoScan(@RequestBody MesPullingOrderInfo mesPullingOrderInfo) {
        try {
            if (StringUtils.isEmpty(mesPullingOrderInfo.getPullingOrderNo())) {
                throw new ImppBusiException("拉动单号不能为空");
            }
            mesPullingOrderInfoService.doMesPullingOrderInfoScan(mesPullingOrderInfo, !StringUtils.isEmpty(mesPullingOrderInfo.getModifyUser())?mesPullingOrderInfo.getModifyUser(): AuthUtil.getSessionUser().getUserName());
            return ResultBean.success("拉动单扫描成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException e) {
            return ResultBean.fail(e).build();
        } catch (Exception e) {
            return ResultBean.fail(e);
        }
    }
    @PostMapping(value = "/doPrint")
    @ApiOperation(value = "打印未打印拉动单后修改状态")
    public ResultBean doMesPullingOrderInfoPrint(@RequestBody MesPullingOrderInfo mesPullingOrderInfo) {
        try {
            if (StringUtils.isEmpty(mesPullingOrderInfo.getWorkCenterCode())) {
                throw new ImppBusiException("产线不能为空");
            }
            List<MesPullingOrderInfo> pullingOrderInfos = mesPullingOrderInfoService.doMesPullingOrderInfoPrint(mesPullingOrderInfo, AuthUtil.getSessionUser().getUserName());
            return ResultBean.success("拉动单打印成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode())
                    .setResultList(pullingOrderInfos);
        } catch (ImppBusiException e) {
            return ResultBean.fail(e).build();
        } catch (Exception e) {
            return ResultBean.fail(e);
        }
    }
    @GetMapping("/template")
    @ApiOperation(value = "查询打印模板和明细")
    public ResultBean queryMesLabelTemplate(MesLabelTemplate labelTemplate ) {
        try {
            ValidatorBean.checkNotNull(labelTemplate.getTemplateCode(), "打印模板不能为空");
            ValidatorBean.checkNotNull(labelTemplate.getOrganizeCode(), "工厂代码不能为空");
            return ResultBean.success("查询成功").setResultObject(mesTemplateService.getMesLabelTemplate(labelTemplate.getTemplateCode(), labelTemplate.getOrganizeCode()));

        } catch (ImppBusiException imppException) {
            return ResultBean.fail(imppException);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }
}
